//+------------------------------------------------------------------+
//|                                                201028_103427.mqh |
//|                                    2019-2020, dimitri pecheritsa |
//|                                                 792112@gmail.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| concrete colleague 2                                             |
//+------------------------------------------------------------------+
#include <Mqh\201028_103044.mqh> //colleague
#include <Mqh\201028_102459.mqh> //mediator
//---
class ConcreteColleague2:public Colleague
  {
protected:
   Mediator*         m_mediator;
public:
                     ConcreteColleague2(Mediator& mediator);
   void              Notify(string message);
   void              Send(string message);
  };
//+------------------------------------------------------------------+
//| constructor                                                      |
//+------------------------------------------------------------------+
ConcreteColleague2::ConcreteColleague2(Mediator& mediator):
   m_mediator(&mediator)
  {
  }
//+------------------------------------------------------------------+
//| notify                                                           |
//+------------------------------------------------------------------+
void ConcreteColleague2::Notify(string message)
  {
   printf("colleague 2 notified about %s",message);
  }
//+------------------------------------------------------------------+
//| send                                                             |
//+------------------------------------------------------------------+
void ConcreteColleague2::Send(string message)
  {
   printf("colleague 2 sending %s",message);
   m_mediator.Send(message,this);
  }
//+------------------------------------------------------------------+
